#include <iostream>

#include <Eigen/Dense>

////TASK B
Eigen::MatrixXd GetA(const Eigen::VectorXd &x) {
	int n = x.size();
	Eigen::MatrixXd A(n, 3);
	// TODO: Task (b)
	// Fill the matrix A.
	// ...
	return A;
}
////END OF TASK B

////TASK C
Eigen::VectorXd LeastSquares(const Eigen::MatrixXd &A, const Eigen::VectorXd &b) {
	// TODO: Task (c)
	// ...
	return b.head(3); // dummy
}
////END OF TASK C

////TASK D
Eigen::MatrixXd BestApprox(const Eigen::MatrixXd &B, int k) {
	Eigen::JacobiSVD<Eigen::MatrixXd> svd(B, Eigen::ComputeThinU | Eigen::ComputeThinV);
	// TODO: Task (d)
	// You may use svd from the line above.
	// ...
	return B; // dummy
}
////END OF TASK D

////TASK E
double FitLineThroughOrigin(const Eigen::MatrixXd &B) {
	// TODO: Task (e)
	// You may use BestApprox from above.
	// ...
	return 0.0; // dummy
}
////END OF TASK E

int main() {
	// Test of Task (b):
	Eigen::VectorXd x(10), y(10);
	x << -1.0, -0.8, -0.6, -0.3, -0.1, 0.1,  0.3, 0.6, 0.8, 1.0;
	y <<  0.0, -0.5, -1.0, -1.1, -1.1,-1.0, -0.5, 0.2, 1.1, 1.9;
	Eigen::MatrixXd A = GetA(x);
	Eigen::VectorXd b = y;
	
	// Test of Task (c):
	Eigen::VectorXd c = LeastSquares(A, b);
	std::cout << "p_c(x) = " << c(2) << " x^2 + " << c(1) << " x + " << c(0) << std::endl;

	// Test of Task (d):
	int k = 2;
	Eigen::MatrixXd B = Eigen::MatrixXd::Identity(4, 3);
	Eigen::MatrixXd Bk = BestApprox(B, k);
	std::cout << "The best rank-" << k << " approximation of" << std::endl
			<< B << std::endl << "is" << std::endl << Bk <<std::endl;

	// Test of Task (e):
	Eigen::MatrixXd B_(2, 6);
	B_ << 0.2, 0.4 , 0.8, 1.0 , 1.2, 1.4,
	      0.2, 0.25, 0.3, 0.37, 0.5, 0.8;
	std::cout << "The slope of the fitted line through the origin is" << std::endl;
	std::cout << "a = " << FitLineThroughOrigin(B_) << std::endl;

	return 0;
}
