#include <cmath>
#include <iostream>

#include <Eigen/Dense>

////TASK A
Eigen::Vector2d f(const Eigen::Vector2d &x) {
	// TODO: Task (a)
	// ...
	return x; // dummy
}
////END OF TASK A

Eigen::Vector2d F(const Eigen::Vector2d &x, const Eigen::Vector2d &zk, double h) {
	return zk + h * f(x) - x;
}

////TASK B
Eigen::Matrix2d DF(const Eigen::Vector2d &x, double h) {
	Eigen::Matrix2d M;
	// TODO: Task (b)
	// ...
	return M;
}
////END OF TASK B

////TASK C
Eigen::Vector2d Newton(Eigen::Vector2d x, double h, int n, double tol) {
	// TODO: Task (c)
	// You may use the functions F and DF defined above.
	// ...
	return x;
}
////END OF TASK C

////TASK D
Eigen::Vector2d QuasiNewton(Eigen::Vector2d x, double h, int n, double tol) {
	// TODO: Task (d)
	// You may use the functions F and DF defined above.
	// ...
	return x;
}
////END OF TASK D

////TASK E
Eigen::Vector2d ImplicitEuler(Eigen::Vector2d z, double h, int N) {
	// TODO: Task (e)
	// Use either Newton or QuasiNewton to solve the non-linear equation.
	// ...
	return z;
}
////END OF TASK E

int main() {
	int N = 100;
	double h = M_PI / (4 * N);
	Eigen::Vector2d z0(0.0, 1.0);
	std::cout << "endtime =    " << N * h << std::endl;
	std::cout << "Impl. Euler: " << ImplicitEuler(z0, h, N)(0) << std::endl;
	std::cout << "exact:       " << std::tan(N * h) << std::endl;
	return 0;
}

